# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
    def self.get_file(dir_s4u_name,s4u_name,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        if File.exist?(file_name_full)
            file= File.new(file_name_full,"r")
            str=file.readlines
            file.close
            return str.collect{|s| s.chomp}
        end
        return false
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
    def self.set_file(dir_s4u_name,s4u_name,list,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        file= File.new(file_name_full, mode: 'w:UTF-8')
        str=list.join("\n")
        file.syswrite str
        file.close
        return true
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
	module S4u_slice
		class Slice
			def initialize(slice_mode=0)
                @scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@scale_factor = 1.5 if @scale_factor>1.8
				@snap=20*@scale_factor
				@slice_mode=slice_mode
                @slice_mode_list=[Strings["Slice"],Strings["Cut"],Strings["Detach"],Strings["Creat Group Section"]]
				@slice_inside_list=[Strings["No Inside"],Strings["Inside"]]
				@plane_type_list=[Strings["Set plane 2 points"],Strings["Set plane 3 points"],
                                    Strings["Set plane by Object"],Strings["Set plane perpendicular Face"],Strings["Set plane perpendicular Ground"]]
				@section_type_list=[Strings["No Section Faces"],Strings["Add Section Faces"],Strings["Add Section Faces(Group)"]]
				@hidden_line_list = [Strings["Show Section Line"],Strings["Hidden Section Line"]]
			end
			def activate
				# ext_lic = Sketchup::Licensing.get_extension_license("82697d52-33df-4bd8-a1a4-0dbab615cdf9")
				# if !ext_lic.licensed?
					# if defined?(S4U::S4u_License)
						# if !S4U::S4u_License.licensed?(self,false,false)
							# if WAREHOUSE
								# UI.messagebox ext_lic.error_description
								# Sketchup.active_model.select_tool(nil) if self.class!=Module
								# return
							# elsif !S4U::S4u_License.licensed?(self)
								# Sketchup.active_model.select_tool(nil) if self.class!=Module
								# return
							# end
						# end
					# else
						# UI.messagebox ext_lic.error_description
						# Sketchup.active_model.select_tool(nil) if self.class!=Module
						# return
					# end
				# end
				@edit_transform=Sketchup.active_model.axes.transformation
				model=Sketchup.active_model
				@sectionplanes=[]
				@ip1=Sketchup::InputPoint.new
				@ip2=Sketchup::InputPoint.new
				@ip3=Sketchup::InputPoint.new
				@ip=Sketchup::InputPoint.new
				@elements=[]
                get_setting()
				@slice_inside=1 if @slice_mode==2
				if @slice_mode==3
					sel=model.selection
					@sectionplanes=sel.select{|e| e.is_a?Sketchup::SectionPlane}
					activesectionplane=@sectionplanes.find{|sp| sp.active?}
					@sectionplanes=[activesectionplane] if activesectionplane
					elements=sel.select{|e| e && e.valid? && ((e.is_a?Sketchup::Edge)||(e.is_a?Sketchup::Face)||(e.is_a?Sketchup::Group)||(e.is_a?Sketchup::ComponentInstance))}
					if !@sectionplanes.empty? and !elements.empty?
						@sectionplanes.each{|sectionplane|
							plane = sectionplane.get_plane.to_a
							v=Geom::Vector3d.new(plane[0],plane[1],plane[2])
							line = [Geom::Point3d.new(0, 0, 0), v]
							p=Geom.intersect_line_plane(line, plane)
							pl=[p,v.reverse]
							process_slice([pl,nil,nil])
						}
						model.select_tool(nil)
					end
				end
				self.reset
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				bb.add @ip1.position if @ip1.valid?
				bb.add @ip2.position if @ip2.valid?
				bb.add @ip3.position if @ip3.valid?
				return bb
			end
			def get_setting()
                @setting = S4U::S4u_slice::instance_variable_get :@setting
				if @setting && (@setting.class==Hash)
                    @slice_inside = @setting["@slice_inside"]
                    @plane_type = @setting["@plane_type"]
                    @section_type = @setting["@section_type"]
                    @hidden_line = @setting["@hidden_line"]
                    @slice_mode= @setting["@slice_mode"] if @slice_mode==4
				else
                    @slice_inside=1
                    @plane_type=0
                    @section_type=1
                    @hidden_line=0
                    s=S4U::get_file(Dir_s4u_name,NAME)
                    if s && s[0]
                        @setting=JSON.parse s[0]
                        @slice_inside = @setting["@slice_inside"]
                        @plane_type = @setting["@plane_type"]
                        @section_type = @setting["@section_type"]
                        @hidden_line = @setting["@hidden_line"]
                        @slice_mode= @setting["@slice_mode"] if @slice_mode==4
                    else
                        @slice_mode=0
                        puts "No get setting"
                    end
                end
                rescue=>error
					@slice_mode=0
					puts "error get setting"
					p error,error.backtrace.join('\n')
				end
			def deactivate(view)
                if @slice_inside && @plane_type && @section_type && @hidden_line && @slice_mode
                    @setting={}
                    @setting["@slice_inside"] = @slice_inside
                    @setting["@plane_type"] = @plane_type
                    @setting["@section_type"] = @section_type
                    @setting["@hidden_line"] = @hidden_line
                    @setting["@slice_mode"] = @slice_mode
                    S4U::S4u_slice::instance_variable_set(:@setting,@setting)
                    (puts "error save setting") if !S4U::set_file(Dir_s4u_name,NAME,[@setting.to_json])
                end
			end
			def setstatus(view=nil)
				text = Strings["Slice Mode"] + ": "
				text+= @slice_mode_list[@slice_mode].upcase + " | "
				text+=Strings["Slice Inside"] + ": "
				text+=@slice_inside_list[@slice_inside].upcase
				text+= " (" + Strings["Press Down for change"] +") "
				text+= " | " + @section_type_list[@section_type]
				text+= " | " + @plane_type_list[@plane_type]
				(text+="(" + Strings["Ctrl -> Lock Zaxis"] + ")" ) if @plane_type==0
				text+=" | "
				(text+=  Strings["Side Cut(Press TAB)"] + " | ") if @slice_mode==1
				if @alt_press
					text+= Strings["Select Object"]
				elsif @state==0 && @plane_type!=2
					text+=Strings["Select First point"]
				elsif @state==1 && @plane_type!=2
					text+= Strings["Select Second point"]
				elsif @state==2 && @plane_type==1
					text+= Strings["Select Third point"]
				elsif @plane_type==2
					text+= Strings["Select Object"]
				elsif @plane_type==3
					text+= Strings["Select First point on Face"]
				end
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
					view.line_width=2
					if @ip && @ip.valid?
						if @ip.display?
							@ip.draw(view)
						elsif @edge
							view.draw_points @ip.position, 7, 1, "red"
						end
					end
                    if @state==0 || @alt_press
                        if (@plane_type==2 || @alt_press) && @ip
                            view.drawing_color ="blue"
                            view.line_width=4
                            if @ip && @trans
                                p=@ip.position
                                length = view.pixels_to_model 15*@scale_factor, p
                                vx=@plane_transform.xaxis
                                vy=@plane_transform.yaxis
                                vx.length=vy.length=length
                                p1=p+(vx+vy)
                                p2=p+(vx.reverse+vy)
                                p3=p+(vx.reverse+vy.reverse)
                                p4=p+(vx+vy.reverse)
                                view.line_width=1
                                view.draw_polyline [p1,p2,p3,p4,p1]
                                view.draw GL_QUADS,[p1,p2,p3,p4]
                                if @slice_mode==1
                                    v=@plane_transform.zaxis
                                    v.length=(view.pixels_to_model 10*@scale_factor, p)
                                    v.reverse! if @rever_plane==0
                                    view.line_width=7
                                    view.drawing_color="orange"
                                    view.draw_polyline (p1+v),(p2+v),(p3+v),(p4+v),(p1+v)
                                end
                            end
                        end
                    elsif @state==1
						if @ip.valid?
							@ip.draw(view)
							if @p_shift
								view.line_stipple = "."
								view.drawing_color ="blue"
								view.draw_line(@ip.position, @ip2.position)
								view.line_stipple = ""
								p2_line=@ip.position.project_to_line([@ip1.position,@p_shift])
								view.draw_points p2_line, 7, 2, "red"  if p2_line
								view.drawing_color = @plane_type==0 ? "red" : "blue"
								view.draw2d GL_LINES,[view.screen_coords(@ip1.position),view.screen_coords(p2_line)]
							end
								if @plane_type==0 && !@ctrl_press
									view.drawing_color ="red"
									view.draw2d GL_LINES,[view.screen_coords(@ip.position),view.screen_coords(@ip1.position)]
								elsif @plane_type==1 && !@ctrl_press
									view.drawing_color ="blue"
									view.draw_line @ip.position,@ip1.position
                                elsif @plane_type==3  && !@ctrl_press
                                    view.drawing_color ="blue"
                                    view.line_width=4
                                    if @ip1.valid? && @ip2.valid? && @ip1.face
                                        length = view.pixels_to_model 20*@scale_factor, @ip1.position
                                        normal=S4U::S4u_slice.normal_face(@ip1.face,@ip1.transformation)
                                        normal.length=length
                                        t=Geom::Transformation.new(@ip1.position,normal)
                                        pt1=@ip1.position.transform t.inverse
                                        pt2=@ip2.position.transform t.inverse
                                        normal.reverse! if pt2.z>pt1.z
                                        pt12=Geom::Point3d.new(pt2.x,pt2.y,pt1.z).transform t
                                        pt21=Geom::Point3d.new(pt1.x,pt1.y,pt2.z).transform t
                                        p1=@ip1.position+(normal)
                                        p2=pt12+(normal)
                                        p3=@ip2.position+(normal.reverse)
                                        p4=pt21+(normal.reverse)
                                        view.line_width=1
                                        view.draw_polyline [p1,p2,p3,p4,p1]
                                        view.draw GL_QUADS,[p1,p2,p3,p4]
                                        if @slice_mode==1
                                            v=@plane_transform.zaxis
                                            v.length=(view.pixels_to_model 10*@scale_factor, @ip1.position)
                                            v.reverse! if @rever_plane==0
                                            view.line_width=7
                                            view.drawing_color="orange"
                                            view.draw_polyline (p1+v),(p2+v),(p3+v),(p4+v),(p1+v)
                                        end
                                    end
                                elsif  @ctrl_press || @plane_type==4
                                    view.drawing_color ="blue"
                                    view.line_width=4
                                    if @ip1.valid? && @ip2.valid?
                                        length = view.pixels_to_model 20*@scale_factor, @ip1.position
                                        normal=Z_AXIS.clone
                                        normal.length=length
                                        t=Geom::Transformation.new(@ip1.position,normal)
                                        pt1=@ip1.position.transform t.inverse
                                        pt2=@ip2.position.transform t.inverse
                                        normal.reverse! if pt2.z>pt1.z
                                        pt12=Geom::Point3d.new(pt2.x,pt2.y,pt1.z).transform t
                                        pt21=Geom::Point3d.new(pt1.x,pt1.y,pt2.z).transform t
                                        p1=@ip1.position+(normal)
                                        p2=pt12+(normal)
                                        p3=@ip2.position+(normal.reverse)
                                        p4=pt21+(normal.reverse)
                                        view.line_width=1
                                        view.draw_polyline [p1,p2,p3,p4,p1]
                                        view.draw GL_QUADS,[p1,p2,p3,p4]
                                        if @slice_mode==1
                                            v=@plane_transform.zaxis
                                            v.length=(view.pixels_to_model 10*@scale_factor, @ip1.position)
                                            v.reverse! if @rever_plane==0
                                            view.line_width=7
                                            view.drawing_color="orange"
                                            view.draw_polyline (p1+v),(p2+v),(p3+v),(p4+v),(p1+v)
                                        end
                                    end
								end
							if @slice_mode==1 && @plane_type!=3 && @plane_type!=4 && !@ctrl_press
								p1=view.screen_coords(@ip1.position)
								p2=view.screen_coords( @p_shift ? @ip.position.project_to_line([@ip1.position,@p_shift]) : @ip.position)
								p2_p1=p2-p1
								p2_p1[2]=0
								v=Z_AXIS.cross p2_p1
								if v and v.length>0
									v.reverse! if @rever_plane==1
									v.length=15
									p11=p1.clone + v
									p21=p2.clone + v
									view.line_width=7
									view.drawing_color="orange"
									view.draw2d GL_LINES,p11,p21
								end
							end
						end
					elsif @state==2
						@ip1.draw(view)
						@ip2.draw(view)
						view.drawing_color="blue"
						view.line_width=3
						view.draw_line @ip1.position,@ip2.position
						if @slice_mode==1
							p1=@ip1.position
							p2=@ip2.position
							p3=@p_shift ? @ip.position.project_to_line([@ip2.position,@p_shift]) : @ip.position
							p2_p1=p2-p1
							p3_p1=p3-p1
							v=p2_p1.cross p3_p1
							if v and v.length>0
								v.reverse! if @rever_plane==1
								size = view.pixels_to_model 15, p1
								v.length=size
								p11=p1.clone + v
								p21=p2.clone + v
								p31=p3.clone + v
								view.line_width=7
								view.drawing_color="orange"
								view.draw_polyline p11,p21,p31,p11
								view.line_width=2
							end
						end
						if @ip3.valid?
							@ip3.draw(view)
							view.drawing_color="#f3162b"
							view.draw GL_TRIANGLES,[(@ip1.position),(@ip2.position),(@ip3.position)]
							view.drawing_color="blue"
							view.line_width=3
							view.draw_line @ip2.position,@ip3.position
							view.draw_line @ip1.position,@ip3.position
						end


					end
				self.setstatus
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(100, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper
				ph.init(x, y)
				picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,20) }
				if picked
					ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
					p=view.screen_coords(picked.transform ip.transformation)
					ip.pick view,p.x,p.y,ip1
					view.tooltip=Strings["1/3"]
				end
				return nil
			end
			def onMouseMove(flags, x, y, view)
                @shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
				@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
				@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)

				@edge=nil;@trans=nil
				ph = view.pick_helper
				ph.do_pick(x, y)
				if @state==0
					@ip.pick view,x,y
					view.tooltip = @ip.tooltip
					@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
					@rever_plane=0 if !@rever_plane
					@face=@ip.face
					@trans=@ip.transformation
					element=ph.best_picked
					@elements=[element] if element
					ip1 = view.inputpoint(x, y,Sketchup::InputPoint.new(@edit_transform.origin))
					p=ip1.position.transform @edit_transform.inverse
                    if !@shift_press || !@plane_transform
                        @plane_transform=@edit_transform
                        if @ip.edge
                            #@plane_transform=Geom::Transformation.new(@ip.position,(@ip.edge.end.position.transform(@trans)-@ip.edge.start.position.transform(@trans)))
                            line=(@ip.edge.end.position.transform(@trans)-@ip.edge.start.position.transform(@trans))
                            line.reverse! if view.screen_coords(@ip.edge.start.position.transform(@trans)).x> view.screen_coords(@ip.edge.end.position.transform(@trans)).x
                            if @edit_transform.zaxis.parallel? line
                                normal=@edit_transform.zaxis
                            else
                                normal=line.cross @edit_transform.zaxis
                            end
                            @plane_transform=Geom::Transformation.new(@ip.position,normal)
                        elsif element.is_a?(Sketchup::ConstructionLine)
                            p=ORIGIN
                            p1=p+element.direction
                            line=p1-p
                            line.reverse! if view.screen_coords(p1).x< view.screen_coords(p).x
                            if @edit_transform.zaxis.parallel? line
                                normal=@edit_transform.zaxis
                            else
                                normal=line.cross @edit_transform.zaxis
                            end
                            @plane_transform=Geom::Transformation.new(@ip.position,normal)
                            view.tooltip=Strings["ConstructionLine"]
                        # elsif ((p.x==0 && p.y==0) || (p.x==0 && p.z==0) || (p.y==0 && p.z==0))
                            # vector =@edit_transform.origin.vector_to ip1.position
                            # if vector.length>0
                                # @plane_transform=Geom::Transformation.new(ip1.position,vector)
                                # view.tooltip=Strings.GetString("Axis")
                            # end
                        elsif (p.y==0 && p.z==0) || (p.x==0 && p.z==0)
                            vector =@edit_transform.origin.vector_to ip1.position
                            vector.reverse! if view.screen_coords(ip1.position).x < view.screen_coords(@edit_transform.origin).x
                            if vector.length>0
                                vz=vector.cross @edit_transform.zaxis
                                if vz.length>0
                                    @plane_transform=Geom::Transformation.new(ip1.position,vz)
                                    view.tooltip=Strings["Axis"]
                                end
                            end
                        elsif @ip.face
                            normal=S4U::S4u_slice.normal_face(@face,@trans)
                            @plane_transform=Geom::Transformation.new(@ip.position,normal)
                        elsif element.is_a?Sketchup::SectionPlane
                            plane = element.get_plane.to_a
                            normal=Geom::Vector3d.new(plane[0],plane[1],plane[2])
                            @plane_transform=Geom::Transformation.new(@ip.position,normal)
                        end
                    end
					view.invalidate if @ip.valid?
				elsif @state==1
					@ip1 = view.inputpoint @xy[0],@xy[1] if @xy && (@plane_type==0)
					best_pick = ph.all_picked
					@elements+= best_pick if best_pick
					@ip.pick view,x,y,@ip1
					view.tooltip = @ip.tooltip
					@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
					if @p_shift && @ip!=@ip1
						p2_line=@ip.position.project_to_line([@ip1.position,@p_shift])
						@ip2.copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
					else
						@ip2.copy! @ip
					end
                    if @plane_type==3 && (@ip1.position.distance(@ip2.position)>1) && @ip1.face
                        vec=@ip1.position.vector_to @ip2.position
						normal=S4U::S4u_slice.normal_face(@ip1.face,@ip1.transformation)
                        vecz=normal.cross(vec)
                        @plane_transform=Geom::Transformation.new(@ip1.position,vecz) if vecz.length>0
                    elsif (@plane_type==4 && (@ip1.position.distance(@ip2.position)>1)) || (@ctrl_press)
                        vec=@ip1.position.vector_to @ip2.position
                        normal=Z_AXIS
                        vecz=normal.cross(vec)
                        @plane_transform=Geom::Transformation.new(@ip1.position,vecz) if vecz.length>0
                    end
					view.invalidate if @ip.valid?
				elsif @state==2
					best_pick = ph.all_picked
					@elements+= best_pick if best_pick
					ip=((@ip.position.distance @ip1.position) < (@ip.position.distance @ip2.position)) ? @ip1 : @ip2
					@ip.pick view,x,y,ip
					view.tooltip = @ip.tooltip
					@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
					if @p_shift && @ip!=@ip1 && @ip!=@ip2
						p2_line=@ip.position.project_to_line([@ip2.position,@p_shift])
						@ip3.copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
					else
						@ip3.copy! @ip
					end
					view.invalidate if @ip.valid?
				end
			end
			def onLButtonDown(flags, x, y, view)
				if @state==0
					if @ip.valid?
						if @plane_type==2 || @alt_press
							p1=@ip.position
							vz=@plane_transform.zaxis
							plane=[[p1,vz],nil,nil]
							process_slice(plane)
                        elsif @plane_type!=3
							@ip1.copy! @ip
							@state=1
							@elements.clear
                        elsif @plane_type==3 && @ip.valid? && @ip.face
							@ip1.copy! @ip
							@state=1
							@elements.clear
						end
					end
				else
					if (@state==1) && @ip.valid? && (@ip1.position!=@ip.position)
						@state=2
						view.lock_inference if view.inference_locked?
						if @plane_type==0  || (@ctrl_press)
							p1=@ip1.position
							p2=@ip2.position
							self.reset(view)
							vx= p1.vector_to p2
							vz=Z_AXIS
							vy=vz.cross vx
							if vy.length>0 && (@ctrl_press)
								self.reset(view)
								plane=[[p1,vy],[p1,vx],[p2,vx.reverse]]
								process_slice(plane)
							else
								model=view.model
								ray=view.pickray x, y
								p1_screen=view.screen_coords p1
								ray1=view.pickray p1_screen.x,p1_screen.y
								vec= p1.vector_to p2
								if ray && ray1
									normal=vec.cross ray[1]
									normal1=vec.reverse.cross ray1[1]
									if normal.length>0 && normal1.length>0
										v1=(ray1[1].cross vec).cross ray1[1]
										v=(ray[1].cross vec).cross ray[1]
										if v.length>0 and v1.length>0
											plane=[[p1,normal],[p1,v1],[p2,v.reverse]]
											process_slice(plane)
										end
									end
								end
							end
						elsif @plane_type==3 || @plane_type==4
                            if @ip1.valid? && @ip2.valid?
                                p1=@ip1.position
                                vz=@plane_transform.zaxis
                                plane=[[p1,vz],nil,nil]
                                self.reset(view)
                                process_slice(plane)
                            end
                        end
					elsif @state==2 && @plane_type==1 && @ip.valid? && (@ip2.position!=@ip.position) &&
                                    ((@ip.position.distance_to_line [@ip1.position,@ip2.position])>0)
						view.lock_inference if view.inference_locked?
						p1=@ip1.position
						p2=@ip2.position
						p3=@ip3.position
						vx= p1.vector_to p2
						p3_line=p3.project_to_line [p1,p2]
						vy=p3_line.vector_to p3
						vz=vy.cross vx
						if vz.length>0
							self.reset(view)
							if Geom.point_in_polygon_2D(p3_line,[p1,p2],true)
								plane=[[p1,vz],[p1,vx],[p2,vx.reverse]]
								process_slice(plane)
							else
								if (p3_line.distance p1) < (p3_line.distance p2)
									plane=[[p1,vz],[p3,vx],[p2,vx.reverse]]
									process_slice(plane)
								else
									plane=[[p1,vz],[p1,vx],[p3,vx.reverse]]
									process_slice(plane)
								end
							end
						end
					end
				end
				self.setstatus(view)
				rescue=>error
				p error
				self.reset(view)
			end
			def process_slice(plane)
				model=Sketchup.active_model
				entities=model.active_entities
				model.start_operation TOOL,true,false,false
				begin
					sel=model.selection.to_a
					ent=[];get_select=true;g=g1=nil
					if sel.empty?
						@elements.flatten!
						@elements.uniq!
						sel=(@elements & model.active_entities.to_a)
						get_select=false
					end
					if sel.length>0
						no_sel=entities.to_a-sel
						start=true
						if (@slice_mode==0)
							S4U::S4u_slice.cut_element(@slice_mode,entities,sel,plane,0,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						elsif @slice_mode==3
							grp=model.active_entities.add_group
							group_section=grp
							plane[1]=nil
							S4U::S4u_slice.cut_element(@slice_mode,entities,sel,plane,0,@slice_inside,@section_type,Geom::Transformation.new,start,group_section,(@hidden_line==1))
							if group_section
								group_section.name=Strings["Section"]
								group_section.material=model.materials.current
								if !@sectionplanes.empty?
									layers = model.layers
									layer_name = layers.unique_name Strings["Section"]
									layer=model.layers.add layer_name
									layer.page_behavior=32
									model.pages.each{|p| p.set_visibility(layer,(p== model.pages.selected_page))}
									group_section.layer=layer
									v=plane[0][1]
									v.length=0.007
									t=Geom::Transformation.new(v)
									group_section.transform! Geom::Transformation.translation(v).inverse
								end
							end
						elsif @slice_mode==1
							plane[1]=nil
							plane[0][1].reverse! if @rever_plane==1
							S4U::S4u_slice.cut_element(@slice_mode,entities,sel,plane,2,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						elsif @slice_mode==2
							plane[1]=nil
							S4U::S4u_slice.cut_element(@slice_mode,entities,sel,plane,2,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						end
						if get_select
							sel=entities.to_a-no_sel
							ent1=sel.select{|e| e && e.valid? && ((e.is_a?Sketchup::Edge)||(e.is_a?Sketchup::Face)||(e.is_a?Sketchup::Group)||(e.is_a?Sketchup::ComponentInstance))}
							model.selection.add ent1 if ent1.length>0
						end
					end
					model.commit_operation
					self.setstatus
				rescue=>error
					p error
					p error.backtrace.join('\n')
					model.abort_operation
				end
			end
			def getMenu(menu)
				menus=[]
				@slice_mode_list.each_index{|i| menus<< menu.add_item(@slice_mode_list[i]) {@slice_mode=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@slice_mode]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@slice_inside_list.each_index{|i| menus<< menu.add_item(@slice_inside_list[i]) {@slice_inside=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@slice_inside]) { MF_CHECKED }
                menu.add_separator
				menus=[]
				@plane_type_list.each_index{|i| menus<< menu.add_item(@plane_type_list[i]) {
                        @plane_type=i
                        if @plane_type==2
                            self.reset
                        end
                    }
                }
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@plane_type]) { MF_CHECKED }
                menu.add_separator
				if @slice_mode==1
					menus<< menu.add_item(Strings["Reverse Side Cut"]){
							@rever_plane=1-@rever_plane
					}
				end
				menu.add_separator
				menus=[]
				@section_type_list.each_index{|i| menus<< menu.add_item(@section_type_list[i]) {@section_type=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@section_type]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@hidden_line_list.each_index{|i| menus<< menu.add_item(@hidden_line_list[i]) {@hidden_line=i }}
				menus.each{|m| menu.set_validation_proc(m){ MF_UNCHECKED }}
				menu.set_validation_proc(menus[@hidden_line]){ MF_CHECKED }
			end
			def onKeyDown(key, repeat, flags, view)
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						@shift_press=true
						self.setstatus(view)
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
						self.setstatus(view)
					end
				else
					if key==CONSTRAIN_MODIFIER_KEY
						@shift_press=true
						if( @state==0 && @ip.valid? )
							view.lock_inference @ip if !@alt_press
						elsif( @state==1 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						elsif( @state==2 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						end
						self.setstatus(view)
					elsif key==VK_UP
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p= ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.zaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_LEFT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p=  ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.yaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_RIGHT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p= ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.xaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=true
						self.setstatus(view)
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
						self.setstatus(view)
					end
				end
			end
			def onKeyUp(key, repeat, flags, view)
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						@shift_press=nil
						self.setstatus(view)
					elsif (key==9) || ((key==48) && IS_OSX)
						(@rever_plane=1-@rever_plane)
						self.setstatus(view)
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=nil
						self.setstatus(view)
					end
				else
					if (key==CONSTRAIN_MODIFIER_KEY)
						view.lock_inference if view.inference_locked?
						@p_shift=nil
						@shift_press=nil
						self.setstatus(view)
					elsif (key==9) || ((key==48) && IS_OSX)
						@rever_plane=1-@rever_plane
						self.setstatus(view)
					elsif key==VK_DOWN
						@slice_inside=1-@slice_inside
						self.setstatus(view)
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
                        @ctrl_press=nil
						self.setstatus(view)
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=nil
						self.setstatus(view)
					end
				end
			end
			def onCancel(reason, view)
				self.reset(view)
			end
			def reset(view=nil)
				view.lock_inference if view
				@state=0
				@ip1.clear
				@ip2.clear
				@ip3.clear
				@ip.clear
				@trans=nil
				self.setstatus(view)
			end
			def resume(view)
				self.setstatus(view)
			end
		end
		def self.cut_element(cut_mode,entities,sel,planes,cut_hide,cut_inside,section_type,t,start,group_section,hidden_line,parent=nil)
			if start
				no_sel=entities.to_a-sel
			end
			plane=planes[0]
			plane1=planes[1]
			plane2=planes[2]
			result=true
			gc=sel.select{|e|  e && e.valid? && (e.is_a?(Sketchup::ConstructionPoint) || e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance))}
			gc.each{|element|
				on_plane=element_on_plane(element,plane,t)
				if on_plane==1
					element.erase! if element && element.valid? && (cut_hide==1 || cut_hide==2 ) && ((start && cut_mode!=2) || (!start))
				elsif on_plane==0 && (element.is_a?(Sketchup::Group) || element.is_a?(Sketchup::ComponentInstance))
					if cut_inside==1
						ent=en1=nil
						element.make_unique if cut_mode!=3
						element1=nil
						if element.is_a?Sketchup::Group
							ent=element.entities
							if cut_mode==2 && start
								element1=element.copy
								element1.make_unique
								S4U::S4u_slice.set_attribute_element(element1,S4U::S4u_slice.get_attribute_element(element))
								ent1=element1.entities
							end
						elsif element.is_a?Sketchup::ComponentInstance
							ent=element.definition.entities
							if cut_mode==2 && start
								element1=entities.add_instance(element.definition,element.transformation)
								element1.make_unique
								S4U::S4u_slice.set_attribute_element(element1,S4U::S4u_slice.get_attribute_element(element))
								ent1=element1.definition.entities
							end
						end
						if ent
							cut_element(cut_mode,ent,ent,planes,cut_hide,cut_inside,section_type,t*element.transformation,false,group_section,hidden_line,element)
							if ent1 && cut_inside==1 && start && cut_mode==2
								element_root=element1
								planes[0]=[planes[0][0],(Geom::Vector3d.new planes[0][1]).reverse]
								cut_element(cut_mode,ent1,ent1,planes,cut_hide,cut_inside,section_type,t*element1.transformation,false,group_section,hidden_line,element)
							end
						end
					end
				end
			}
			faces=[];edges=[]
			faces=sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Face)}
			faces.each{|e|
				points=[]
				e.edges.each{|ed|
					ps=ed.start.position.transform t
					pe=ed.end.position.transform  t
					p=Geom.intersect_line_plane([ps,pe], plane)
					(points<< p) if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
				}
				points=points.sort{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
				(0..points.length-2).each{|i|
					if points[i]!= points[i+1]
						p1=points[i].clone.transform((t).inverse)
						p2=points[i+1].clone.transform((t).inverse)
						pl=e.classify_point(Geom::Point3d.linear_combination(0.5,p1,0.5,p2))
						if (pl==1) || (pl==2) || (pl==4)
							ps=points[i]
							pe=points[i+1]
							if plane1 && plane2
								ps_on_plane = (point_on_plane(ps,plane1)>=0)
								pe_on_plane = (point_on_plane(pe,plane1)>=0)
								p1=p2=nil
								if points_on_plane([ps,pe],plane1) || (ps_on_plane && pe_on_plane)
									p1=ps;p2=pe
								elsif ps_on_plane || pe_on_plane
									point_plane=Geom.intersect_line_plane([ps,pe], plane1)
									if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
										if ps_on_plane
											p1=ps;p2=point_plane
										elsif pe_on_plane
											p1=point_plane;p2=pe
										end
									end
								end
								if p1 && p2
									ps=p1.clone
									pe=p2.clone
									p1=p2=nil
									ps_on_plane = (point_on_plane(ps,plane2)>=0)
									pe_on_plane = (point_on_plane(pe,plane2)>=0)
									if points_on_plane([ps,pe],plane2) || (ps_on_plane && pe_on_plane)
										p1=pe;p2=ps
									elsif (point_on_plane(ps,plane2)>=0)  || (point_on_plane(pe,plane2)>=0)
										point_plane=Geom.intersect_line_plane([ps,pe], plane2)
										if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
											if ps_on_plane
												p1=ps;p2=point_plane
											elsif pe_on_plane
												p1=point_plane;p2=pe
											end
										end
									end
									if p1 && p2
										p1=p1.transform((t).inverse)
										p2=p2.transform((t).inverse)
										edges << [p1,p2]
									end
								end
							else
								p1=ps.transform((t).inverse)
								p2=pe.transform((t).inverse)
								edges << [p1,p2]
							end
						end
					end
				}
			}
			if group_section
				edges_new=[]
				g=group_section.entities.add_group
				edges.each{|e|
					edge=g.entities.add_edges(e[0],e[1])
					if (cut_hide==1) || (cut_hide==2)
						edge1= entities.add_edges(e[0],e[1])
						(edge1[0].hidden=hidden_line) if edge1 && edge1[0] && (edge1[0].is_a?Sketchup::Edge)
					end
					if edge && edge[0] && (edge[0].is_a?Sketchup::Edge)
						edge[0].soft=true if cut_hide==1 || !cut_hide
						edge[0].hidden=hidden_line
						edges_new << edge[0]
					end
				}
				if section_type!=0
					edges_new.uniq!
					faces=g.entities.grep(Sketchup::Face)
					edges_new.each{|e| e.find_faces}
					faces_new= g.entities.grep(Sketchup::Face) - faces
					fs=self.delete_hole(faces_new)
					fs.each{|f|
						if f && f.valid? && (f.is_a?Sketchup::Face)
							vec=self.normal_face(f,t)
							f.reverse!  if (!(vec.samedirection?(plane[1]))) || (vec.angle_between(plane[1])>=(Math::PI*0.5))
						end
					}
				end
				g.transform! t
				if section_type!=2
					(g.explode if g && g.valid?)
				elsif parent
					S4U::S4u_slice.set_attribute_element(g,S4U::S4u_slice.get_attribute_element(parent))
					S4U::S4u_slice.copy_attribute_dictionaries(parent.definition,g.definition)
				end
			else
				g=entities.add_group
				edges_new=[]
				edges.each{|e|
					edge=g.entities.add_edges(e[0],e[1])
					if (cut_hide==1) || (cut_hide==2)
						edge1= entities.add_edges(e[0],e[1])
						(edge1[0].hidden=hidden_line) if edge1 && edge1[0] && (edge1[0].is_a?Sketchup::Edge)
					end
					if edge && edge[0] && (edge[0].is_a?Sketchup::Edge)
						edge[0].soft=true if cut_hide==1 || !cut_hide
						edge[0].hidden=hidden_line
						edges_new << edge[0]
					end
				}
				if section_type!=0
					edges_new.uniq!
					faces=g.entities.grep(Sketchup::Face)
					edges_new.each{|e| e.find_faces}
					faces_new= g.entities.grep(Sketchup::Face) - faces
					fs=self.delete_hole(faces_new)
					fs.each{|f|
						if f && f.valid? && (f.is_a?Sketchup::Face)
							vec=self.normal_face(f,t)
							f.reverse!  if (!(vec.samedirection?(plane[1]))) || (vec.angle_between(plane[1])>=(Math::PI*0.5))
						end
					}
				end
				if section_type!=2
					(g.explode if g && g.valid?)
				elsif parent
					S4U::S4u_slice.set_attribute_element(g,S4U::S4u_slice.get_attribute_element(parent))
					S4U::S4u_slice.copy_attribute_dictionaries(parent,g)
				end
			end
			ent_edges=sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}
			addedges=[]
			ent_edges.each{|ed|
				ps=ed.start.position.transform t # world ucs t*element.transformation
				pe=ed.end.position.transform  t
				p=Geom.intersect_line_plane([ps,pe], plane)
				if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
					addedges<< p.transform((t).inverse)
				end
			}
			addedges.each{|ep|  entities.add_line(ep,ep)}
			@count=0 if start || !@count
			Sketchup.status_text= Strings["Procesing level:"] +"#{@count}"
			@count+=1
			if ( (cut_hide==1) || (cut_hide==2) ) && ((start && cut_mode!=2) || (!start))
				length_ent_edges=(sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge)}).length
				loop =0 ;j=0 ;length_ent_edges_new=0
				while (length_ent_edges != (length_ent_edges_new+j)) && (loop<5) do
					ent_edges=sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}
					addedges=[]
					ent_edges.each{|ed|
						ps=ed.start.position.transform t # world ucs t*element.transformation
						pe=ed.end.position.transform  t
						p=Geom.intersect_line_plane([ps,pe], plane)
						if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
							addedges<< p.transform((t).inverse)
						end
					}
					sel=entities.to_a-no_sel if start
					length_ent_edges=(sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}).length
					ver=[] ;ver1=[] ;ver_face=[]
					sel.each{|e|
						if e && (!e.deleted?) && (e.is_a?Sketchup::Face)
							e.edges.each{|ed|
								ps=ed.start.position.transform t
								pe=ed.end.position.transform  t
								ver_face<< ed if points_on_plane([ps,pe],plane)
							}
						end
					}
					sel.each{|e|
						if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && e.faces.length==0
							ps=e.start.position.transform t
							pe=e.end.position.transform t
							if points_on_plane([ps,pe],plane)
								if point_on_plane(ps,plane)==0 || point_on_plane(pe,plane)==0
									ver1<< e
								else
									ver<< e
								end
							end
						end
					}
					ver.uniq!
					ver1.uniq!
					j=0
					begin
					ver1.each{|e| (e.erase!;j+=1) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
					ver.each{|e|(e.erase!;j+=1) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
					ver_face.each{|e|(e.erase!) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
					rescue =>error
					p error
					p error.backtrace.join('\n')
					end
					loop+=1
					length_ent_edges_new=(sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}).length
				end
			end
		end
		def self.delete_hole(faces)
			faces1=faces.clone
			fd=[]
			i=0
			length=faces.length
			while (faces.length > 0) &&(i< length)
				f=faces.shift
				(f.loops - [f.outer_loop]).each{|l|
					fs=l.edges[0].faces
					l.edges.each{|e| fs= e.faces & fs }
					(fs-[f]).each{|fa|
						if fa.valid? && fa.loops.length>1
							faces = faces - [fa]
							fd<< fa
						end
					}
				}
				i+=1
			end
			fd.uniq!
			faces=faces1-fd
			fd1=[]
			i=0
			length=faces.length
			while (faces.length > 0) && (i< length)
				f=faces.shift
				(f.loops - [f.outer_loop]).each{|l|
					fs=l.edges[0].faces
					l.edges.each{|e| fs = e.faces & fs}
					(fs-[f]).each{|fa|
						 if  fa.valid?
							 faces = faces - [fa]
							 fd1<< fa
						 end
					 }
				}
				i+=1
			end
			fd1.uniq!
			faces1 -= (fd1 + fd)
			(fd1 + fd).each{|f| f.erase! if f && f.valid?}
			return faces1
			rescue => error
			p error
			p error.backtrace.join('\n')
			return nil
		end
		def self.points_on_plane(points,plane)
			p1=points[0].clone;p2=points[1].clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			p2.transform! t_plane.inverse
			return (((p1.z>0) && (p2.z>=0)) || ((p1.z>=0) && (p2.z>0)))
		end
		def self.point_on_plane(point,plane)
			p1=point.clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			return p1.z
		end
		def self.normal_face(face,t=Sketchup.active_model.edit_transform)
			vx=nil;vy=nil;line=nil
			ver=face.outer_loop.vertices.collect{|v| v.position.transform t}
			(0..ver.length-2).each{|i|
				vx=ver[i].vector_to ver[i+1]
				line=ver[i],ver[i+1]
				if vx.length!=0 && line
					(0..ver.length-1).each{|i|
						v2=ver[i].project_to_line line
						vy=v2.vector_to ver[i]
						break if vy.length!=0
					}
					normal=vx.cross vy if vx && vy
					if normal.length!=0
						facenormal=face.normal.transform t
						normal.reverse! if (normal.angle_between facenormal) >= Math::PI*0.5
						return normal
					end
				end
			}
			return face.normal
		end
		def self.element_on_plane(element,plane,t=Geom::Transformation.new)
			corner=[]
			if element.is_a?(Sketchup::ConstructionPoint)
				corner<< element.position.transform(t)
			else
				bounds=element.bounds
				corner=(0..7).collect{|i| bounds.corner(i).transform(t)}
				corner << bounds.center.transform(t)
			end
			if corner.all?{|c| point_on_plane(c,plane)>0}
				return 1
			elsif corner.all?{|c| point_on_plane(c,plane)<0}
				return -1
			end
			return 0
			rescue
			return 0
		end
		def self.get_attribute_element(element)
			return {"layer"=>element.layer,"hidden"=>element.hidden?,"material"=>element.material,
					"casts_shadows"=>element.casts_shadows?,"receives_shadows"=>element.receives_shadows?}
		end
		def self.set_attribute_element(element,hash)
			hash.each{|k,v|
				if k=="layer"
					element.layer=v
				elsif k=="hidden"
					element.hidden=v
				elsif k=="material"
					element.material=v
				elsif k=="casts_shadows"
					element.casts_shadows=v
				elsif k=="receives_shadows"
					element.receives_shadows=v
				end
			}
			return element
		end
		def self.copy_attribute_dictionaries(parent,g)
			attrdicts = parent.attribute_dictionaries
			attrdicts.each{|attrdict|
				if attrdict.name
					g.attribute_dictionary(attrdict.name,true)
					attrdict.each_pair { | key, value |
						g.set_attribute attrdict.name,key,value
					}
				end
			} if attrdicts
			return true
			rescue =>error
			p error
			p error.backtrace.join('\n')
			return false
		end
		def self.main(slice_mode=0)
			# ext_lic = Sketchup::Licensing.get_extension_license("82697d52-33df-4bd8-a1a4-0dbab615cdf9")
			# if !ext_lic.licensed?
				# if defined?(S4U::S4u_License)
					# if !S4U::S4u_License.licensed?(self,false,false)
						# if WAREHOUSE
							# UI.messagebox ext_lic.error_description
							# Sketchup.active_model.select_tool(nil) if self.class!=Module
							# return
						# elsif !S4U::S4u_License.licensed?(self)
							# Sketchup.active_model.select_tool(nil) if self.class!=Module
							# return
						# end
					# end
				# else
					# UI.messagebox ext_lic.error_description
					# Sketchup.active_model.select_tool(nil) if self.class!=Module
					# return
				# end
			# end
			Sketchup.active_model.select_tool Slice.new(slice_mode)
		end
	end
end